{% extends 'base.html.twig' %}

{% block title %}Home{% endblock %}

{% block body %}
    <style>
        .example-wrapper { margin: 1em auto; max-width: 800px; width: 95%; font: 18px/1.5 sans-serif; }
        .example-wrapper code { background: #F5F5F5; padding: 2px 6px; }
    </style>

    <div class="container">
        <h1 class="h3 mb-3 font-weight-normal">HomePage</h1>
        {% if app.user %}
            <div class="col-md-2 offset-10 Infos">
                <p>Date:  {{ "now"|date("d/m/Y") }}</p>
                <p>User: {{ app.user.nickname }}</p>
            </div>
        {% endif %}
    <h5>Filter Events</h5>
        <br>
        <div class="row filtre">
            <div class="col-md-5 col-xs-12 filtreGauche">
                <label for="SelectSite">Site: </label>
                <select id="SelectSite">
                    <option value="-1" selected>-- Select one site --</option>
                </select><br><label for="SearchBar">By Name: </label>
                <input type="text" id="SearchBar"><br>
                Beetwen: <input type="date" id="dateSince"> And: <input type="date" id="dateUntil">
            </div>
            <div class="col-md-4 col-xs-12 filtreCentre">
                <input type="checkbox" id="cbOrganizer">
                <label for="cbOrganizer">Events for which I am the organizer</label><br>
                <input type="checkbox" id="cbRegister">
                <label for="cbRegister">Events in which I am registered</label><br>
                <input type="checkbox" id="cbNotRegister">
                <label for="cbNotRegister">Events in which I am not registered</label><br>
                <input type="checkbox" id="cbPast">
                <label for="cbPast">Events past</label>
            </div>
            <div class="col-md-2 col-xs-12 filtreDroit">
                <button type="button" class="btn btn-lg btn-primary btnSearch" onclick="addFilters({{ app.user.id }})">Search <img src="/Image/search-3-xxl.png" class="Icone"></button>
            </div>
        </div>
        <br>
        <div class="col-xs-12">
            <table  class="table" id="tableEvent">
                <tr>
                    <th>Name</th>
                    <th>Date</th>
                    <th>End Registration</th>
                    <th>Registered/Places</th>
                    <th>State</th>
                    <th>Registered</th>
                    <th>Organizer</th>
                    <th>Actions</th>
                </tr>
                <tbody id="tb">
                </tbody>
            </table>
        </div>
        <br>
        <a href="{{ path('event_create') }}"><button class="btn btn-lg btn-primary" type="button">+ Create event</button></a>
    </div>

    <div id="cover-spin"></div>

{% endblock %}

{% block javascript %}
<script>
    var user;
    var allEvents;
    //Fonction lancer au chargement de la page
    $( document ).ready(function() {
        addLoader();
        addSite();
        GetUser({{ app.user.id }}).then(()=>{
            GetListEvent(user.id).then(()=>{
                refreshAllListEvent()
            });
        });

    });

    function addLoader()
    {
        $('#cover-spin').show();
    }

    function removeLoader(){
        $('#cover-spin').hide();
    }

     function addSite(){
        $.ajax({
                url : '{{ path('GetListSite')}}',
                    success : function(data){
                        for(var i=0; i< data.length; i++){
                            $('#SelectSite').append('<option value="'+ data[i].id +'">' + data[i].name + '</option>')
                        }
                    }
            });
    }

    //Recupère le user connecté
    function GetUser(id)
    {
        return $.ajax({
            url : '{{ path('GetUserById')}}' + '/' + id,
                success : function(data){
                    user = data[0];
                }
        });
    };

    //Recupère la liste d'évènements
    function GetListEvent(id)
    {
        return $.ajax({
            url : '{{ path('GetListEvent')}}' + '/' + id,
            success : function(data){
                myEvents = [];
                var dateLimit = new Date();
                dateLimit.setMonth(dateLimit.getMonth()-1);

                data.forEach((currentEvent) =>{
                    var currentEndTime = new Date(
                        new Date(currentEvent.startDatetime) + new Date(currentEvent.duration * 60)
                        * 1000);
                    console.log(currentEndTime)
                    if(currentEndTime > dateLimit ){
                        myEvents.push(currentEvent);
                    }
                })
                allEvents = myEvents;
            }
        });
    };

    function refreshAllListEvent() {
            for(var i=0; i< allEvents.length; i++)
            {
                addRow(allEvents[i], user)
            }
            removeLoader();
    }

    //Ajoute une ligne dans le tableau d'évènements
    function addRow(data, user) {
            var dateStart = new Date(data.startDatetime);
            var day = ('0'+ (dateStart.getDate())).slice(-2);;
            var month = ('0'+ (dateStart.getMonth()+ 1)).slice(-2);
            var year = dateStart.getFullYear();
            var hour =  dateStart.getHours();
            var minute = ('0'+ dateStart.getMinutes()).slice(-2);

            var endDate = new Date(data.registrationDeadline);
            var dayEnd = ('0'+ (endDate.getDate())).slice(-2);
            var monthEnd = ('0'+ (endDate.getMonth())).slice(-2);
            var yearEnd = endDate.getFullYear();

            var join = 'No';
            var organizer = 'No';

            for(var i =0; i<user.events.length; i++){
                if(user.events[i].id == data.id){
                    join = 'Yes';
                }
            }
            if(data && data.organizer && data.organizer.id == user.id){
                organizer = 'Yes';
            }
             $('#tableEvent #tb').append('<tr id="' + data.id + '"><td>' + data.name + '</td>' +
                                    '<td>' + day + '/' + month + '/' + year + ' at ' + hour + ':' + minute + '</td>' +
                                    '<td>' + dayEnd + '/' + monthEnd + '/' + yearEnd + '</td>' +
                                    '<td>' + data.users.length + '/' + data.maxUserNumber + '</td>' +
                                    '<td>' + data.state.strState + '</td>' +
                                    '<td id="Join">' + join + '</td>' +
                                    '<td>' + data.organizer.nickname + '</td>' +
                                    '<td id="ListButton"> ' +
                                     '<a href="/event/detail/'+ data.id +'" id="btnRead" class="BtnHome">Read</a>' +
                                     '<a href="/event/update/'+ data.id +'" id="btnUpdate" class="BtnHomeOrganizer">Update</a>' +
                                     '<button id="btnWithdraw" class="BtnHome" onclick="EventWithdraw(' + data.id + ',' + user.id +  ')">withdraw</button>' +
                                     '<button id="btnJoin" class="BtnHome" onclick="EventJoin(' + data.id + ',' + user.id +  ')">Join</button>' +
                                     '<button id="btnPublished" class="BtnHomeOrganizer" onclick="EventPublished(' + data.id + ',' + user.id +  ')">Publish</button>' +
                                     '<a href="/event/cancel/'+ data.id +'" id="btnCanceled" class="BtnHomeOrganizer">Cancel</a>' +
                                     '</td></tr>');

             addButton(data.state.strState, data.id, join, organizer);
    };

    function addButton(state, eventId, join, organizer){
        switch (state) {
          case 'Created':
              if(organizer == 'Yes'){
                  $('#' + eventId + ' #btnUpdate').attr('style', 'display: block');
                  $('#' + eventId + ' #btnPublished').attr('style', 'display: block');
              }else{
                  $('#' + eventId + ' #btnRead').attr('style', 'display: block');
              }

              break;
          case 'Open':
              if(join == 'Yes' && organizer == 'Yes')
                  {
                      $('#' + eventId + ' #btnRead').attr('style', 'display: block');
                      $('#' + eventId + ' #btnWithdraw').attr('style', 'display: block');
                      $('#' + eventId + ' #btnCanceled').attr('style', 'display: block');
                  }else if(join == 'No' && organizer == 'Yes'){
                      $('#' + eventId + ' #btnRead').attr('style', 'display: block');
                      $('#' + eventId + ' #btnJoin').attr('style', 'display: block');
                      $('#' + eventId + ' #btnCanceled').attr('style', 'display: block');
                  }else if (join == 'Yes' && organizer == 'No'){
                      $('#' + eventId + ' #btnRead').attr('style', 'display: block');
                      $('#' + eventId + ' #btnWithdraw').attr('style', 'display: block');
                  }else{
                      $('#' + eventId + ' #btnRead').attr('style', 'display: block');
                      $('#' + eventId + ' #btnJoin').attr('style', 'display: block');
                  }
              break;
          case 'Closed':
              if(join == 'Yes'){
                  $('#' + eventId + ' #btnRead').attr('style', 'display: block');
                  $('#' + eventId + ' #btnWithdraw').attr('style', 'display: block');
              }else{
                  $('#' + eventId + ' #btnRead').attr('style', 'display: block');
              }
              break;
          case 'In progress':
              if(join == 'Yes'){
                  $('#' + eventId + ' #btnRead').attr('style', 'display: block');
                  $('#' + eventId + ' #btnWithdraw').attr('style', 'display: block');
              }else{
                  $('#' + eventId + ' #btnRead').attr('style', 'display: block');
              };
              break;
          case 'Past':
              if(join == 'Yes'){
                  $('#' + eventId + ' #btnRead').attr('style', 'display: block');
                  $('#' + eventId + ' #btnWithdraw').attr('style', 'display: block');
              }else{
                  $('#' + eventId + ' #btnRead').attr('style', 'display: block');
              }
              break;
        }
    }

    function EventJoin(EventId, UserId)
        {
             $.ajax({
                url : '{{ path('event_join')}}' + '/' + EventId,
                    success : function(){
                        addLoader();
                        $('#tableEvent #tb').empty();
                        GetUser(UserId).then(()=>{
                        GetListEvent().then(()=>{
                            refreshAllListEvent()
                            });
                        });

                }
            });
        }

    function EventWithdraw(EventId, UserId)
        {
             $.ajax({
                url : '{{ path('event_leave')}}' + '/' + EventId,
                    success : function(){
                        addLoader();
                        $('#tableEvent #tb').empty();
                        GetUser(UserId).then(()=>{
                        GetListEvent().then(()=>{
                            refreshAllListEvent()
                            });;
                        });

                }

            });
        }

    function EventPublished(EventId, UserId)
        {
             $.ajax({
                url : '{{ path('event_published')}}' + '/' + EventId,
                    success : function(){
                       addLoader();
                        $('#tableEvent #tb').empty();
                        GetUser(UserId).then(()=>{
                        GetListEvent().then(()=>{
                            refreshAllListEvent()
                            });
                        });
                    }
            });
        }

    function EventCancel(EventId, UserId)
        {
             $.ajax({
                url : '{{ path('event_cancel')}}' + '/' + EventId,
                    success : function(){
                        addLoader();
                        $('#tableEvent #tb').empty();
                        GetUser(UserId).then(()=>{
                        GetListEvent().then(()=>{
                            refreshAllListEvent()
                            });
                        });
                    }
            });
        }

    async function addFilters(UserId){
        var finalEvents = [];
        var addedIds = [];
        var hasFilter=false;
        addLoader();
        if(document.getElementById('cbOrganizer').checked){
            hasFilter = true;
            events = filterEventsOrganizer();
            events.forEach(event => {
                 if(!addedIds.includes(event.id)) {
                     addedIds.push(event.id);
                     finalEvents.push(event);
                 }

             })
        }
        if(document.getElementById('cbRegister').checked){
            hasFilter = true;
            events=filterEventsRegister();
            events.forEach(event => {
                 if(!addedIds.includes(event.id)) {
                     addedIds.push(event.id);
                     finalEvents.push(event);
                 }
             })
        }
        if(document.getElementById('cbNotRegister').checked){
            hasFilter = true;
            events = filterEventsNotRegister();
            events.forEach(event => {
                 if(!addedIds.includes(event.id)) {
                     addedIds.push(event.id);
                     finalEvents.push(event);
                 }
             })
        }
        if(document.getElementById('cbPast').checked){
            hasFilter = true;
            events = filterEventsPast();
            events.forEach(event => {
                 if(!addedIds.includes(event.id)) {
                     addedIds.push(event.id);
                     finalEvents.push(event);
                 }
             })
        }

        if ($('#SelectSite option:selected').val() > 0){
            hasFilter = true;
            var site = $('#SelectSite :selected').val();
            events = filterEventsSite(site);
            //events = await GetEventBySite(site);
            events.forEach(event => {
                 if(!addedIds.includes(event.id)) {
                     addedIds.push(event.id);
                     finalEvents.push(event);
                 }
             })
        }

        if(!document.getElementById('SearchBar').value == ""){
            hasFilter = true;
            var name = document.getElementById('SearchBar').value;
            events = filterEventsByName(name);
            events.forEach(event => {
                 if(!addedIds.includes(event.id)) {
                     addedIds.push(event.id);
                     finalEvents.push(event);
                 }
             })
        }

        if(document.getElementById('dateSince').value != "" && document.getElementById('dateUntil').value != "")
            {
                hasFilter = true;
                var dateSince = document.getElementById('dateSince').value;
                var dateUntil = document.getElementById('dateUntil').value;
                var events = filterEventsBySinceAndUntil(dateSince, dateUntil);
                // events = await GetEventByDate(dateSince, dateUntil);
                events.forEach(event => {
                     if(!addedIds.includes(event.id)) {
                         addedIds.push(event.id);
                         finalEvents.push(event);
                     }
                })
            }


        if(finalEvents.length == 0 && hasFilter == false) {
            finalEvents = allEvents;
        } else if(finalEvents.length == 0){
            alert("No results....")
        }

      $('#tableEvent #tb').empty();
        for(var i=0; i<finalEvents.length; i++){
            addRow(finalEvents[i], user);
        }
        removeLoader()
    }

    function GetEventByOrganizer(UserId){
        return $.ajax({
                url : '{{ path('GetEventByOrganizer')}}' + '/' + UserId,
                    success : function(data){
                    return data;
                    }
            });

    }

    function GetEventRegisterById(UserId){
        return $.ajax({
                url : '{{ path('GetEventRegisterById')}}' + '/' + UserId,
                    success : function(data){
                    return data;
                    }
            });
    }

    function GetEventNotRegisterById(UserId){
        return $.ajax({
                url : '{{ path('GetEventNotRegisterById')}}' + '/' + UserId,
                    success : function(data){
                    return data;
                    }
            });
    }

    function GetEventPast(){
        return $.ajax({
                url : '{{ path('GetEventPast')}}',
                    success : function(data){
                    return data;
                    }
            });
    }

    function GetEventByName(name){
         return $.ajax({
                url : '{{ path('GetEventByName')}}' + '/' + name,
                    success : function(data){
                    return data;
                    }
            });
    }

    function GetEventBySite(idSite){
        return $.ajax({
                url : '{{ path('GetEventBySite')}}' + '/' + idSite,
                    success : function(data){
                    return data;
                    }
            });
    }

    function GetEventByDate(dateSince, dateUntil){
        return $.ajax({
                url : '{{ path('GetEventByDate')}}' + '/' + dateSince + '/' + dateUntil,
                    success : function(data){
                    return data;
                    }
            });
    }

    function filterEventsOrganizer() {
        var results = allEvents.filter(myevent => myevent.organizer.id == user.id);
        return results;
    }

    function filterEventsRegister(){
        var results = user.events;
        return results;
    }

     function filterEventsNotRegister(){
        var myEvents = []
        allEvents.forEach((currentEvent)=>{
            if (currentEvent.users.filter(currentUser => currentUser.id == user.id).length<=0) {
                myEvents.push(currentEvent);
            }
        })
        return myEvents;
    }

    function filterEventsPast(){
        var myEvents = [];
        var dateNow = Date.now();
        allEvents.forEach((currentEvent)=>{
            var currentDateEnd = new Date(new Date(currentEvent.startDatetime) + new Date(currentEvent.duration * 60)) * 1000;
            if(currentDateEnd < dateNow ){
                myEvents.push(currentEvent);
            }
        })
        return myEvents;
    }

    function filterEventsSite(idSite){
        var results = allEvents.filter(myevent => myevent.site.id == idSite);
        return results;
    }

    function filterEventsBySinceAndUntil(since, until) {

        var myEvents = [];
        var dateSince = new Date(since);
        var dateUntil = new Date(until);
        allEvents.forEach((currentEvent)=>{
            var currentStartTime = new Date((currentEvent.startDatetime ) * 1000);
            if(dateSince< currentStartTime && currentStartTime < dateUntil){
                myEvents.push(currentEvent);
            }
        })
        return myEvents;
    }

    function filterEventsByName(name) {
        var results = allEvents.filter(myevent => myevent.name.includes(name));
        return results;
    }

</script>
{% endblock %}
